#pragma once
#include "PublicLib.h"
#include "AqBusDecodeSetting.h"

//====================================================================
class AQcI64Array : public CObject
{
public:
	AQcI64Array();
	~AQcI64Array();
	bool IsEmpty() { return !m_iPtr; };
	void RemoveAll() { m_iPtr = 0; };
	void RemoveTail() { m_iPtr--; };
	ARINT GetSize() { return m_iPtr; };
	ARINT Add( ARINT nData ); 
	ARINT GetPrev()
	{
		if( m_iPtr > 0 )
			return GetAt(m_iPtr-1);
		else
			return 0;
	};

	ARINT*  GetData() { return m_pI64Data; };
	void    SetSize(INT_PTR nNewSize, INT_PTR nGrowBy = -1);	
#ifdef _DEBUG
	void    SetAt(ARINT nIndex, ARINT newElement);
	ARINT   GetAt(ARINT nIndex);
#else
	void    SetAt(ARINT nIndex, ARINT newElement) { m_pI64Data[nIndex] = newElement; };
	ARINT   GetAt(ARINT nIndex) { return m_pI64Data[nIndex]; };	
#endif
protected:
	ARINT		m_iPtr;
	//int			m_iSize;
	ARINT*		m_pI64Data;   // the actual array of data
	INT_PTR		m_nMaxSize;  // max allocated
	INT_PTR		m_nGrowBy;   // grow amount
};

class AQcUIntArray : public CUIntArray
{
public:
	AQcUIntArray() { m_iPtr = 0; };
	virtual ~AQcUIntArray() {};
	void RemoveAll() { m_iPtr = 0; };
	void RemoveTail() { m_iPtr--; };
	int GetSize() { return m_iPtr; };
	int Add( UINT nData ) 
	{ 
		if( m_iPtr == CUIntArray::GetSize() )
			SetSize( CUIntArray::GetSize() + 256*1024 );
		SetAt( m_iPtr, nData ); 
		m_iPtr++;
		return m_iPtr-1;
	};
	UINT GetPrev()
	{
		if( m_iPtr > 0 )
			return GetAt(m_iPtr-1);
		else
			return 0;
	};

protected:
	int			m_iPtr;
	int			m_iSize;
};
//====================================================================

class cAqBusDecodeAnalysis
{
public:
	cAqBusDecodeAnalysis(void);
	~cAqBusDecodeAnalysis(void);
	bool Analysis(LPDECODECFG lpDecodeCfg);
	bool AnalysisLoop();
	int ConvertMsg(LPDECODECFG lpDecodeCfg, int *piData, char* pszBuf, int iBufSize, int *piColorIdx);
	void BuildCSV(LPDECODECFG lpDecodeCfg, I64 *pi64RetBoundary, UINT *pnRetData, int iRetDataSize);
	void BuildCSVGo(I64 *pi64RetBoundary, UINT *pnRetData, int iRetDataSize);

	AQcUIntArray	m_iaData; 
	AQcI64Array	    m_iaBoundary;
	HANDLE			m_hMapFile;
	//Time range
	TRIDX m_iBegin, m_iEnd, m_i64CurrIdx, m_i64DataIdx, m_i64Boundary;
private:
	LPDECODECFG m_lpDecodeCfg;
	BYTE		m_pWaveBuf[32];
	int			m_iChClk, m_iChData;
};
