// AqBusDecodeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AqBusDecode.h"
#include "AqBusDecodeAnalysis.h"
#include "AqBusDecodeDlg.h"


// cAqBusDecodeDlg dialog

IMPLEMENT_DYNAMIC(cAqBusDecodeDlg, CDialog)

cAqBusDecodeDlg::cAqBusDecodeDlg(LPDECODECFG lpDecodeCfg, CWnd* pParent /*=NULL*/)
	: CDialog(cAqBusDecodeDlg::IDD, pParent)
{
	m_lpDecodeCfg = lpDecodeCfg;
	m_pAqBusDecodeSetting = new cAqBusDecodeSetting(m_lpDecodeCfg);
}

cAqBusDecodeDlg::~cAqBusDecodeDlg()
{
	delete m_pAqBusDecodeSetting;
}

void cAqBusDecodeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BMPPARA, m_bmpPara);
	DDX_Control(pDX, IDC_BMPCOLOR, m_bmpColor);
	DDX_Control(pDX, IDC_BMPRANGE, m_bmpRange);
	DDX_Control(pDX, IDCANCEL, m_bnCancel);
	DDX_Control(pDX, IDC_BEGIN, m_Begin);
	DDX_Control(pDX, IDC_END, m_End);
	DDX_Control(pDX, IDC_STCLK, m_stChClk);
	DDX_Control(pDX, IDC_STDATA, m_stChData);
	DDX_Control(pDX, IDC_SPCLK, m_spChClk);
	DDX_Control(pDX, IDC_SPDATA, m_spChData);
	DDX_Control(pDX, IDC_COLOR01, m_cbColor01);
	DDX_Control(pDX, IDC_COLOR02, m_cbColor02);
	DDX_Control(pDX, IDC_COLOR03, m_cbColor03);
}


BEGIN_MESSAGE_MAP(cAqBusDecodeDlg, CDialog)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_DEFAULT, &cAqBusDecodeDlg::OnBnClickedDefault)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPCLK, &cAqBusDecodeDlg::OnDeltaposSpclk)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPDATA, &cAqBusDecodeDlg::OnDeltaposSpdata)
	ON_BN_CLICKED(IDOK, &cAqBusDecodeDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, &cAqBusDecodeDlg::OnBnClickedCancel)
END_MESSAGE_MAP()


// cAqBusDecodeDlg message handlers

void cAqBusDecodeDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	// TODO: Add your message handler code here
	// Do not call CDialog::OnPaint() for painting messages
	CRect       rcCtrl, rcClient;
	CPen		penGray( PS_SOLID, 1, RGB( 128, 128, 128 ) );
	CPen		penWhite( PS_SOLID, 1, RGB( 255, 255, 255 ) );
	CPen		*ppenOld;
	
	GetClientRect( &rcClient );

	// b w]/Tw/ Weju
	ppenOld = dc.SelectObject( &penGray );
	m_bnCancel.GetClientRect( &rcCtrl );
	m_bnCancel.MapWindowPoints( this, &rcCtrl );
	dc.SelectObject( &penGray );
	dc.MoveTo( rcClient.left + 5, rcCtrl.top - 10 );
	dc.LineTo( rcClient.right - 5, rcCtrl.top - 10 );
	dc.SelectObject( &penWhite );
	dc.MoveTo( rcClient.left + 5, rcCtrl.top - 9 );
	dc.LineTo( rcClient.right - 5, rcCtrl.top - 9 );
	
	// eTICON
	CDC dcMem;
	dcMem.CreateCompatibleDC( &dc );
	CBitmap	bmpIcon, *pbmpOld;
	bmpIcon.LoadBitmap( IDB_ICONLIB );
	pbmpOld = dcMem.SelectObject( &bmpIcon );

	// ]D]wICON
	m_bmpPara.GetClientRect( &rcCtrl );
	m_bmpPara.MapWindowPoints( this, &rcCtrl );
	dc.BitBlt( rcCtrl.left, rcCtrl.top, 32, 32, &dcMem, 0, 0, SRCINVERT );
	dc.BitBlt( rcCtrl.left, rcCtrl.top, 32, 32, &dcMem, 0, 32, SRCAND );
	dc.BitBlt( rcCtrl.left, rcCtrl.top, 32, 32, &dcMem, 0, 0, SRCINVERT );

	// iCICON
	m_bmpColor.GetClientRect( &rcCtrl );
	m_bmpColor.MapWindowPoints( this, &rcCtrl );
	dc.BitBlt( rcCtrl.left, rcCtrl.top, 32, 32, &dcMem, 32, 0, SRCINVERT );
	dc.BitBlt( rcCtrl.left, rcCtrl.top, 32, 32, &dcMem, 32, 32, SRCAND );
	dc.BitBlt( rcCtrl.left, rcCtrl.top, 32, 32, &dcMem, 32, 0, SRCINVERT );

	// ܽdICON
	m_bmpRange.GetClientRect( &rcCtrl );
	m_bmpRange.MapWindowPoints( this, &rcCtrl );
	dc.BitBlt( rcCtrl.left, rcCtrl.top, 32, 32, &dcMem, 64, 0, SRCINVERT );
	dc.BitBlt( rcCtrl.left, rcCtrl.top, 32, 32, &dcMem, 64, 32, SRCAND );
	dc.BitBlt( rcCtrl.left, rcCtrl.top, 32, 32, &dcMem, 64, 0, SRCINVERT );

	dcMem.SelectObject( pbmpOld );
	dc.SelectObject( ppenOld );
}

BOOL cAqBusDecodeDlg::OnInitDialog()
{
	CColorPicker *cbColor[COLOR_COUNT] = {&m_cbColor01, &m_cbColor02, &m_cbColor03};
	CDialog::OnInitDialog();

	// TODO:  Add extra initialization here
	// Channel
	m_spChClk.SetRange(0, m_lpDecodeCfg->iLaMaxCh - 1);
	m_spChClk.SetBase(1);
	m_spChClk.SetPos32(m_pAqBusDecodeSetting->GetChClk());

	m_spChData.SetRange(0, m_lpDecodeCfg->iLaMaxCh - 1);
	m_spChData.SetBase(1);
	m_spChData.SetPos32(m_pAqBusDecodeSetting->GetChData());

	// Range
	m_Begin.SetCurSel( m_pAqBusDecodeSetting->GetBegin() );
	m_End.SetCurSel( m_pAqBusDecodeSetting->GetEnd() );

	// Color
	for( int i = 0 ; i < COLOR_COUNT ; i++ )
	{
		m_cbColor[i] = cbColor[i];
		m_cbColor[i]->Initialize();
		m_cbColor[i]->SetCurSel(m_pAqBusDecodeSetting->GetColor(i));
	}

	if(!(m_lpDecodeCfg->wFlag & WFLAG_USED))
		OnBnClickedDefault();

	UpdateSpin2Edit();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void cAqBusDecodeDlg::DefaultSettings(void)
{
	m_pAqBusDecodeSetting->SetDefault();

	m_lpDecodeCfg->wFlag = WFLAG_USED;
	m_lpDecodeCfg->fRetCode = true;
}

void cAqBusDecodeDlg::UpdateSpin2Edit(CStatic* pstCh, int iVal)
{
	CString csChannelName;

	csChannelName.Format(_T("CH %d"), iVal);
	pstCh->SetWindowText(csChannelName.GetBuffer());
}

void cAqBusDecodeDlg::UpdateSpin2Edit(void)
{
	UpdateSpin2Edit(&m_stChClk, m_spChClk.GetPos32());
	UpdateSpin2Edit(&m_stChData, m_spChData.GetPos32());
}

void cAqBusDecodeDlg::OnDeltaposSpclk(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	// TODO: Add your control notification handler code here
	CSpinButtonCtrl* pspCh = (CSpinButtonCtrl*)GetDlgItem(pNMHDR->idFrom);

	if( !pspCh )
		return;
	if(pNMUpDown->iDelta + pNMUpDown->iPos < 0 || pNMUpDown->iDelta + pNMUpDown->iPos > (int)pspCh->GetRange())
		return;

	UpdateSpin2Edit(&m_stChClk, pNMUpDown->iDelta + pNMUpDown->iPos);
	*pResult = 0;
}

void cAqBusDecodeDlg::OnDeltaposSpdata(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	// TODO: Add your control notification handler code here
	CSpinButtonCtrl* pspCh = (CSpinButtonCtrl*)GetDlgItem(pNMHDR->idFrom);

	if( !pspCh )
		return;
	if(pNMUpDown->iDelta + pNMUpDown->iPos < 0 || pNMUpDown->iDelta + pNMUpDown->iPos > (int)pspCh->GetRange())
		return;

	UpdateSpin2Edit(&m_stChData, pNMUpDown->iDelta + pNMUpDown->iPos);
	*pResult = 0;
}

void cAqBusDecodeDlg::OnBnClickedDefault()
{
	// TODO: Add your control notification handler code here
	DefaultSettings();

	// Channel
	m_spChClk.SetPos32(m_pAqBusDecodeSetting->GetChClk());
	m_spChData.SetPos32(m_pAqBusDecodeSetting->GetChData());

	// Range
	m_Begin.SetCurSel( m_pAqBusDecodeSetting->GetBegin() );
	m_End.SetCurSel( m_pAqBusDecodeSetting->GetEnd() );

	// Color
	for( int i = 0 ; i < COLOR_COUNT ; i++ )
		m_cbColor[i]->SetCurSel(m_pAqBusDecodeSetting->GetColor(i));

	UpdateSpin2Edit();
}

void cAqBusDecodeDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	// Channel
	m_pAqBusDecodeSetting->SetChClk(m_spChClk.GetPos32());
	m_pAqBusDecodeSetting->SetChData(m_spChData.GetPos32());

	// Range
	m_pAqBusDecodeSetting->SetBegin(m_Begin.GetCurSel());
	m_pAqBusDecodeSetting->SetEnd(m_End.GetCurSel());

	// Color
	for( int i = 0 ; i < COLOR_COUNT ; i++ )
		m_pAqBusDecodeSetting->SetColor(i, m_cbColor[i]->GetCurSel());

	m_lpDecodeCfg->wFlag = WFLAG_USED;
	m_lpDecodeCfg->fRetCode = true;

	OnOK();
}

void cAqBusDecodeDlg::OnBnClickedCancel()
{
	// TODO: Add your control notification handler code here
	m_lpDecodeCfg->fRetCode = false;
	OnCancel();
}
