#include "StdAfx.h"
#include "AqBusDecodeSetting.h"

cAqBusDecodeSetting::cAqBusDecodeSetting(LPDECODECFG lpDecodeCfg)
{
	m_lpDecodeCfg = lpDecodeCfg;
}

cAqBusDecodeSetting::~cAqBusDecodeSetting(void)
{
}

void cAqBusDecodeSetting::SetBegin(int iIdx)
{
	int iIndex;

	iIndex = (iIdx & RANGE_MASK) << RANGE_BEGIN_SHIFT;

	m_lpDecodeCfg->iPara[0] &= ~(RANGE_BEGIN);
	m_lpDecodeCfg->iPara[0] |= iIndex;
}

int cAqBusDecodeSetting::GetBegin(void)
{
	return (m_lpDecodeCfg->iPara[0] & RANGE_BEGIN) >> RANGE_BEGIN_SHIFT;
}

void cAqBusDecodeSetting::SetEnd(int iIdx)
{
	int iIndex;

	iIndex = (iIdx & RANGE_MASK) << RANGE_END_SHIFT;

	m_lpDecodeCfg->iPara[0] &= ~(RANGE_END);
	m_lpDecodeCfg->iPara[0] |= iIndex;
}

int cAqBusDecodeSetting::GetEnd(void)
{
	return (m_lpDecodeCfg->iPara[0] & RANGE_END) >> RANGE_END_SHIFT;
}

void cAqBusDecodeSetting::SetDefault(void)
{
	// Channel
	for( int i = 0 ; i < CHANNEL_CNT ; i++ )
		m_lpDecodeCfg->iCh[i] = i;

	// Range
	SetBegin(0);
	SetEnd(0);

	// Color
	for( int i = 0 ; i < COLOR_COUNT ; i++ )
		SetColor(i, i);
}

void cAqBusDecodeSetting::SetChClk(int iChID)
{
	m_lpDecodeCfg->iCh[0] = iChID;
}

int cAqBusDecodeSetting::GetChClk(void)
{
	return m_lpDecodeCfg->iCh[0];
}

void cAqBusDecodeSetting::SetChData(int iChID)
{
	m_lpDecodeCfg->iCh[1] = iChID;
}

int cAqBusDecodeSetting::GetChData(void)
{
	return m_lpDecodeCfg->iCh[1];
}

void cAqBusDecodeSetting::SetColor(int iIdx, int iColorID)
{
	UINT iID, iMask;
	int *piPara;

	if( iIdx < COLOR_PER_PARA )
		piPara = &(m_lpDecodeCfg->iPara[1]);
	else
	{
		piPara = &(m_lpDecodeCfg->iPara[2]);
		iIdx -= COLOR_PER_PARA;
	}

	iID = iColorID & COLOR_MASK;
	iID <<= (COLOR_BITS * iIdx);
	iMask = COLOR_MASK << (COLOR_BITS * iIdx);

	*piPara &= ~iMask;
	*piPara |= iID;
}

int cAqBusDecodeSetting::GetColor(int iIdx)
{
	UINT iID, iMask;
	int *piPara;

	if( iIdx < COLOR_PER_PARA )
		piPara = &(m_lpDecodeCfg->iPara[1]);
	else
	{
		piPara = &(m_lpDecodeCfg->iPara[2]);
		iIdx -= COLOR_PER_PARA;
	}

	iMask = COLOR_MASK << (COLOR_BITS * iIdx);
	iID = *piPara & iMask;
	iID >>= (COLOR_BITS * iIdx);

	return iID;
}
