#pragma once
#include "PublicLib.h"

// Channel Index
//	Control Channel (Fixed order)
//		m_lpDecodeCfg->iChID[0] : CLK
//		m_lpDecodeCfg->iChID[1] : DAT
#define CH_IDX_START	0	// Start ChIdx of Channel
#define CHANNEL_CNT		2	// 2 Channel

// m_lpDecodeCfg->iPara[0]
//	Range
#define RANGE_MASK		0x0000000F	// 4 bits per setting
#define RANGE_ALL		0x000000FF
#define RANGE_BEGIN		0x0000000F	// Begin position
#define RANGE_END		0x000000F0	// End position

#define RANGE_BEGIN_SHIFT	0		// Begin
#define RANGE_END_SHIFT		4		// End

// m_lpDecodeCfg->iPara[1]
// m_lpDecodeCfg->iPara[2]
//	Color
#define COLOR_COUNT		3			// ϥcolor, ̦his16
#define COLOR_MASK		0x0000000F	// 4 bits per setting(color)
#define COLOR_BITS		4			// 4 bits per color
#define COLOR_PER_PARA	(32 / COLOR_BITS)	// number of color per iPara

class cAqBusDecodeSetting
{
public:
	cAqBusDecodeSetting(LPDECODECFG lpDecodeCfg);
	~cAqBusDecodeSetting(void);
	void SetBegin(int iIdx);
	int GetBegin(void);
	void SetEnd(int iIdx);
	int GetEnd(void);
	void SetDefault(void);
	void SetChClk(int iChID);
	int GetChClk(void);
	void SetChData(int iChID);
	int GetChData(void);
	void SetColor(int iIdx, int iColorID);
	int GetColor(int iIdx);
private:
	LPDECODECFG m_lpDecodeCfg;
};
